SystemOrganization addCategory: #RoassalObsolete!
SystemOrganization addCategory: 'RoassalObsolete-Builder-CharterOLD'!
SystemOrganization addCategory: 'RoassalObsolete-Builder-Matrix'!
SystemOrganization addCategory: 'RoassalObsolete-Builder-MemoryProfiler'!
SystemOrganization addCategory: 'RoassalObsolete-EvalLoop'!

Object subclass: #RTReadEvalLoop
	instanceVariableNames: 'view currentText currentElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RoassalObsolete-EvalLoop'!

RTReadEvalLoop class
	instanceVariableNames: 'icon'!

RTReadEvalLoop class
	instanceVariableNames: 'icon'!

!RTReadEvalLoop class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 9/21/2014 17:14'!
menuCommandOn: aBuilder
	<worldMenu>

	(aBuilder item: #'Roassal evaluator')
		order: 0.1; 
		parent: #Roassal;
		label: 'Roassal evaluator';
		icon: RTIcon smallRoassal;
		action:[ self new open ]! !

!RTReadEvalLoop class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 3/30/2014 23:08'!
readme

"
Doit to import a new icon in .png

 ThemeIcons createIconMethodsFromFile: 'RoassalWithTransparent' directory: '/Users/alexandrebergel/Documents/ObjectProfile/Logos'
"! !

!RTReadEvalLoop class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 3/30/2014 23:08'!
roassalWithTransparentIcon
	"Private - Generated method"
	^ icon ifNil: [ icon := Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self roassalWithTransparentIconContents readStream) ].! !

!RTReadEvalLoop class methodsFor: 'logo' stamp: 'akevalion 7/18/2014 18:08'!
roassalWithTransparentIconContents
	"Private - Method generated with the content of the file C:\Users\azazael\Documents\smalltalk\inti\moose\roassalWithTransparent.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAAAoAAAASCAYAAABit09LAAABLElEQVR4XmP4//8/w38iMFGK
aK1wWo/Z/8Tgiv86UhP+a0vX/9eRbvuvLbnyv57U1P8zek2givoFgArmAvFSoKKS/1N7pf5P
6xX7P7XHCaj4zv/EiEKIQh2pLqCgNxCHACX+/58xkQtuk7bkGaB4JYQztVfh//nzjECBnP/a
Umf+z+oTAooZ/teTbgA6J+//qaPSCDeePsYJFGwFmj7jv4F0E1DDrP9W8oX/Tx0TRfeMzn8d
yTVAT3j/15WqBiq8+j80lBnT11N7goHuOf1/2kTu//Nni/031egCalz1//Rx9v9XTjEiKwS6
T/ICmH3lCsP/7CQHoKlf/ieGRP/PCndCKNSRnAzE+1ACWk/GAyh28r+udAFC0EwvDBheYYRj
ZsEC5v+nTjENwtQDAHm03ZBoT2X8AAAAAElFTkSuQmCC'! !

!RTReadEvalLoop methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 3/30/2014 23:02'!
displayLine: aString! !

!RTReadEvalLoop methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 5/10/2014 17:54'!
enterCharacter: c
	currentText := currentText, c asString.
	currentElement trachelShape text: currentText! !

!RTReadEvalLoop methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 3/30/2014 23:03'!
enterLine: aText
	currentText := aText.
	currentElement trachelShape text: currentText! !

!RTReadEvalLoop methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 3/30/2014 23:06'!
enterLine: aText color: aColor
	currentText := aText.
	currentElement trachelShape 
							color: aColor;
							text: currentText! !

!RTReadEvalLoop methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 3/30/2014 22:59'!
initialize
	super initialize.
	view := RTView new.
	view when: TRKeyDown do: [ :evt | self keyStroke: evt ].
	self newLine! !

!RTReadEvalLoop methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 3/30/2014 23:03'!
keyStroke: evt
	| c |
	evt keyValue = 13
		ifTrue: [ ^ self pressEnter ].
	c := evt keyValue asCharacter.
	self enterCharacter: c.
	self refresh! !

!RTReadEvalLoop methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 3/30/2014 22:59'!
newLine
	currentElement := RTLabel new elementOn: '?'.
	currentText := ''.
	view add: currentElement! !

!RTReadEvalLoop methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 3/30/2014 22:53'!
open
	view open! !

!RTReadEvalLoop methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 5/10/2014 17:56'!
pressEnter
	self scrollDown.
	self newLine.

	self scrollDown.
	self enterLine: '-->', currentText size printString color: Color blue.
	self newLine.
	self scrollDown.
	self refresh! !

!RTReadEvalLoop methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 3/30/2014 23:01'!
refresh
	view canvas signalUpdate! !

!RTReadEvalLoop methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 3/30/2014 23:02'!
scrollDown
	view elements do: [ :e | e translateBy: 0 @ -20 ]! !

RTObject subclass: #InstanceSpy
	instanceVariableNames: 'classesToMonitor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RoassalObsolete-Builder-MemoryProfiler'!

!InstanceSpy methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 2/12/2014 20:43'!
example01
	"
	self new example01
	"

	| spy |
	spy := InstanceSpy new.
	spy monitor: TRMouseMove.
	spy monitor: TRMouseEnter.
	spy monitor: TRMouseLeave.
	spy open! !

!InstanceSpy methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 2/12/2014 21:04'!
example04
	"
	self new example04
	"

	| spy |
	spy := InstanceSpy new.
	spy monitor: RTElement.
	spy monitor: RTEdge.
	spy monitor: RTLabel.
	spy monitor: TRMouseEnter.
	spy monitor: TRMouseLeave.
	spy monitor: TRMouseMove.
	spy open.
	spy! !

!InstanceSpy methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 2/12/2014 20:37'!
initialize
	super initialize.
	classesToMonitor := OrderedCollection new! !

!InstanceSpy methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 2/12/2014 20:39'!
monitor: aClass
	classesToMonitor add: aClass! !

!InstanceSpy methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 2/12/2014 20:38'!
numberOfClassesToMonitor
	^ classesToMonitor size! !

!InstanceSpy methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 2/12/2014 21:16'!
open

	| view shape elements |
	view := RTView new.
	shape := RTBox new size: [ :cls | ((cls allInstances size + 1) log * 40) max: 5 ].
	elements := shape elementsOn: classesToMonitor.
	elements @ (RTPopup new text: [ :cls | self textInfoFor: cls ]) .
	view addAll: elements.
	RTGridLayout on: view elements.

	view addAnimation: (RTRefreshShapes new view: view; elements: view elements; yourself).
	view open
	
! !

!InstanceSpy methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 2/12/2014 20:53'!
textInfoFor: cls

	| s |
	s := WriteStream on: String new.
	s nextPutAll: cls name.
	s nextPutAll: ' => '.
	s nextPutAll: cls allInstances size printString.
	s nextPutAll: ' instances'.
	^ s contents! !

RTObject subclass: #RTRefreshShapes
	instanceVariableNames: 'view refreshValue elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RoassalObsolete-Builder-MemoryProfiler'!

!RTRefreshShapes methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 2/12/2014 21:01'!
addedIn: aCanvas! !

!RTRefreshShapes methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 2/12/2014 21:16'!
elements: elementsToRefresh
	elements := elementsToRefresh! !

!RTRefreshShapes methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 2/12/2014 20:58'!
hasCompleted
	^ false! !

!RTRefreshShapes methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 2/12/2014 21:16'!
initialize
	super initialize.
	refreshValue := 0.
	elements := #()! !

!RTRefreshShapes methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 2/12/2014 21:16'!
refresh
	refreshValue := refreshValue + 1.
	refreshValue < 10 ifTrue: [ ^ self ].
	refreshValue := 0.

	elements do: #update.
	RTGridLayout on: elements.! !

!RTRefreshShapes methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 2/12/2014 21:01'!
start! !

!RTRefreshShapes methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 2/12/2014 21:00'!
view: aView
	view := aView! !

TestCase subclass: #InstanceSpyTest
	instanceVariableNames: 'spy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RoassalObsolete-Builder-MemoryProfiler'!

!InstanceSpyTest methodsFor: 'running' stamp: 'AlexandreBergel 2/12/2014 20:38'!
setUp
	super setUp.
	spy := InstanceSpy new! !

!InstanceSpyTest methodsFor: 'tests' stamp: 'AlexandreBergel 2/12/2014 20:38'!
testDefault

	self assert: spy numberOfClassesToMonitor equals: 0! !

!InstanceSpyTest methodsFor: 'tests' stamp: 'AlexandreBergel 2/12/2014 20:39'!
testNumberOfClassesToMonitor
	spy monitor: Announcer.
	self assert: spy numberOfClassesToMonitor equals: 1.
	spy monitor: InstanceSpy.
	self assert: spy numberOfClassesToMonitor equals: 2! !

RTBuilder subclass: #RTCharterBuilder
	instanceVariableNames: 'extent lastAddedElements minY maxY minX maxX allPointElements axisConfiguration datasets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RoassalObsolete-Builder-CharterOLD'!

!RTCharterBuilder commentStamp: '<historical>' prior: 0!
A RTCharterBuilder is a builder to chart data points.

Instance Variables
	allPointElements:		<Object>
	axisConfiguration:		<Object>
	extent:		<Object>
	lastAddedElements:		<Object>
	maxX:		<Object>
	maxY:		<Object>
	minX:		<Object>
	minY:		<Object>

allPointElements
	- xxxxx

axisConfiguration
	- xxxxx

extent
	- xxxxx

lastAddedElements
	- xxxxx

maxX
	- xxxxx

maxY
	- xxxxx

minX
	- xxxxx

minY
	- xxxxx
!

!RTCharterBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 10/14/2014 21:46'!
add: aDataSet
	datasets add: aDataSet.
	aDataSet builder: self! !

!RTCharterBuilder methodsFor: 'public' stamp: 'AlexandreBergel 9/11/2014 19:05'!
adjustMinAndMaxValues
	"Values are adjusted to always have 0 @ 0 in the chart"
	minY > 0
		ifTrue: [ minY := 0 ].
	maxY < 0
		ifTrue: [ maxY := 0 ].
		
	minX > 0
		ifTrue: [ minX := 0 ].
	maxX < 0
		ifTrue: [ maxX := 0 ].! !

!RTCharterBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 7/14/2014 11:34'!
allPointElements
	^ allPointElements! !

!RTCharterBuilder methodsFor: 'public' stamp: 'AlexandreBergel 7/31/2014 18:29'!
allPoints
	^ allPointElements flatCollect: #yourself! !

!RTCharterBuilder methodsFor: 'public-scatterplot' stamp: 'AlexandreBergel 9/22/2014 13:53'!
allX: metricAsBlockOrSymbol
	"
	PUBLIC METHOD
	This methods takes as an argument a symbol or a block. The argument will be invoked on _all_ data point to compute the position on the X-axis.  
	"
	| vs |
	"We compute the min and the max, useful for labelling"
	vs := self allPoints collect: [ :e | metricAsBlockOrSymbol rtValue: e model ].
	minX := minX min: vs min.
	maxX := maxX max: vs max.

	RTMetricNormalizer new
		elements: self allPoints;
		normalizeX: metricAsBlockOrSymbol min: 0 max: extent x minValue: 0.


! !

!RTCharterBuilder methodsFor: 'public' stamp: 'AlexandreBergel 10/10/2014 09:56'!
allY: metricAsBlockOrSymbol
	"
	PUBLIC METHOD
	This methods takes as an argument a symbol or a block. The argument will be invoked on _all_ data point to compute the position on the Y-axis.  
	"
	
	| vs |
	"We compute the min and the max"
	vs := self allPoints collect: [ :e | metricAsBlockOrSymbol rtValue: e model ].
	minY := minY min: vs min.
	maxY := maxY max: vs max.

	self adjustMinAndMaxValues.
	
	"We normalize the things"
	RTMetricNormalizer new
		elements: self allPoints;
		normalizeY: [ :model | (metricAsBlockOrSymbol rtValue: model) ] min: 0 max: extent y negated minValue: minY maxValue: maxY.
! !

!RTCharterBuilder methodsFor: 'public-axis' stamp: 'AlexandreBergel 8/14/2014 18:39'!
axisConfiguration
	"Return an instance of RTAxisConfiguration. This method is useful to let a script to particularize the axis"
	^ axisConfiguration! !

!RTCharterBuilder methodsFor: 'utility' stamp: 'AlexandreBergel 12/8/2014 17:58'!
axisPointFor: aPoint
	"Return the position in the view to have the 0 @ 0"
	| centralPointX centralPointY diffBetweenMaxAndMin |
	diffBetweenMaxAndMin := self maxX - self minX.
	diffBetweenMaxAndMin = 0 ifTrue: [ 100 ] ifFalse: [ diffBetweenMaxAndMin ].
	centralPointX := aPoint x + ((extent x - aPoint x) * ((aPoint x - self minX) / diffBetweenMaxAndMin )) asInteger.
	centralPointY := aPoint y + ((extent y - aPoint y) * ((aPoint y - self minY) / diffBetweenMaxAndMin)) asInteger.
	^ centralPointX @ centralPointY negated.
! !

!RTCharterBuilder methodsFor: 'public-axis' stamp: 'AlexandreBergel 9/11/2014 18:55'!
axisX
	| centralPoint |
	centralPoint := self centralPoint.
	axisConfiguration 
		positionLabel: [ :aLabel :aTick | aLabel translateTo: aTick position + (0 @ 15) ];
		minValue: ((minX > 0) ifTrue: [ 0 ] ifFalse: [ minX ]);
		maxValue: maxX.	

	axisConfiguration axisFrom: 0 @ centralPoint y to: extent x @ centralPoint y! !

!RTCharterBuilder methodsFor: 'public-axis' stamp: 'AlexandreBergel 10/10/2014 10:19'!
axisXNoLabel
	| config centralPoint |
	config := RTAxisConfiguration new
					builder: self;
					numberOfTicks: 0;
					numberOfLabels: 0;
					minValue: ((minX > 0) ifTrue: [ 0 ] ifFalse: [ minX ]);
					maxValue: maxX.
	centralPoint := self centralPoint.
	config axisFrom: 0 @ centralPoint y to: extent x @ centralPoint y! !

!RTCharterBuilder methodsFor: 'public-axis' stamp: 'AlexandreBergel 8/14/2014 19:28'!
axisXTitled: aTitle
	axisConfiguration title: aTitle.
	self axisX! !

!RTCharterBuilder methodsFor: 'public-axis' stamp: 'AlexandreBergel 9/3/2014 19:26'!
axisXWithNumberOfTicks: nbOfTicks
	| config centralPoint |
	config := RTAxisConfiguration new
					builder: self;
					numberOfTicks: nbOfTicks;
					numberOfLabels: nbOfTicks;
					minValue: ((minX > 0) ifTrue: [ 0 ] ifFalse: [ minX ]);
					maxValue: maxX;					
					labelConvertion: [ :number | number asFloat round: 2 ];
					positionLabel: [ :aLabel :aTick | aLabel translateTo: aTick position + (0 @ 15) ].
	centralPoint := self centralPoint.
	config axisFrom: 0 @ centralPoint y to: extent x @ centralPoint y! !

!RTCharterBuilder methodsFor: 'public-axis' stamp: 'AlexandreBergel 9/3/2014 19:26'!
axisY
	| centralPoint |
	centralPoint := self centralPoint.
	axisConfiguration 
		positionLabel: [ :aLabel :aTick | aLabel translateTo: aTick position - (40 @ 0) ];
		minValue: ((minY > 0) ifTrue: [ 0 ] ifFalse: [ minY ]);
		maxValue: maxY.	

	axisConfiguration axisFrom: centralPoint x @ 0 to: centralPoint x @ extent y negated! !

!RTCharterBuilder methodsFor: 'public-axis' stamp: 'AlexandreBergel 8/14/2014 19:28'!
axisYTitled: aTitle
	axisConfiguration title: aTitle.
	self axisY! !

!RTCharterBuilder methodsFor: 'public-axis' stamp: 'AlexandreBergel 9/3/2014 19:26'!
axisYWithNumberOfTicks: nbOfTicks
	| config centralPoint |
	config := RTAxisConfiguration new
					builder: self;
					numberOfTicks: nbOfTicks;
					numberOfLabels: nbOfTicks;
					minValue: ((minY > 0) ifTrue: [ 0 ] ifFalse: [ minY ]);
					maxValue: maxY;
					labelConvertion: [ :number | number asFloat round: 2 ];
					positionLabel: [ :aLabel :aTick | aLabel translateTo: aTick position - (40 @ 0) ].
	centralPoint := self centralPoint.
	config axisFrom: centralPoint x @ 0 to: centralPoint x @ extent y negated! !

!RTCharterBuilder methodsFor: 'utility' stamp: 'AlexandreBergel 8/8/2014 15:44'!
bottomPoint
	"Return the position in the view to have the 0 @ 0"
	^ self axisPointFor: 0 @ minY! !

!RTCharterBuilder methodsFor: 'utility' stamp: 'AlexandreBergel 8/8/2014 15:44'!
centralPoint
	"Return the position in the view to have the 0 @ 0"
	^ self axisPointFor: 0 @ 0! !

!RTCharterBuilder methodsFor: 'public-curve' stamp: 'AlexandreBergel 7/31/2014 20:07'!
connectDot
	self connectDotColor: Color lightGray! !

!RTCharterBuilder methodsFor: 'public-curve' stamp: 'AlexandreBergel 7/31/2014 13:16'!
connectDotColor: aColor
	self connectDotUsing: (RTLine new color: aColor)! !

!RTCharterBuilder methodsFor: 'public-curve' stamp: 'AlexandreBergel 7/31/2014 13:15'!
connectDotUsing: aLineShape
	| t |
	t := lastAddedElements first.
	lastAddedElements allButFirst
		do: [ :tt | 
			view add: (aLineShape edgeFrom: t to: tt).
			t := tt ]! !

!RTCharterBuilder methodsFor: 'hooks' stamp: 'AlexandreBergel 7/13/2014 20:53'!
createView

	^ super createView @ RTDraggableView! !

!RTCharterBuilder methodsFor: 'public-curve' stamp: 'AlexandreBergel 7/13/2014 23:26'!
curve
	"connect the points in the order they have been added"
	^ self curveUsing: RTLine new! !

!RTCharterBuilder methodsFor: 'public-curve' stamp: 'AlexandreBergel 8/8/2014 11:43'!
curveUsing: aLineShape
	"connect the points in the order they have been added"

	"This is highly inefficent."
	RTMetricNormalizer new
		elements: lastAddedElements;
		normalizeElementX: [ :element | lastAddedElements indexOf: element ] min: 0 max: extent x minValue: 1 maxValue: lastAddedElements size.
	minX := 0.
	maxX := lastAddedElements size - 1.
	self connectDotUsing: aLineShape! !

!RTCharterBuilder methodsFor: 'initialization' stamp: 'AlexandreBergel 7/14/2014 05:37'!
defaultMaxValue
	^ 1000000! !

!RTCharterBuilder methodsFor: 'initialization' stamp: 'AlexandreBergel 7/14/2014 05:37'!
defaultMinValue
	^ -1000000! !

!RTCharterBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 7/13/2014 15:19'!
extent
	^ extent! !

!RTCharterBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 7/13/2014 15:19'!
extent: aValue
	extent := aValue! !

!RTCharterBuilder methodsFor: 'public-highlight' stamp: 'AlexandreBergel 8/2/2014 13:20'!
highlightIf: aConditionalBlock using: aBlock

	self allPoints do: [ :element |
		(aConditionalBlock rtValue: element model) ifTrue: [ 
			element @ (RTLabelled new text: [ :model | aBlock rtValue: model ]; setAsHighlightable).
		]
	]! !

!RTCharterBuilder methodsFor: 'public-highlight' stamp: 'AlexandreBergel 8/2/2014 14:08'!
highlightIf: aConditionalBlock using: aBlock lowColor: lowColor color: highColor

	self allPoints do: [ :element |
		(aConditionalBlock rtValue: element model) ifTrue: [ 
			element @ (RTLabelled new 
							lowColor: lowColor;
							text: [ :model | aBlock rtValue: model ]; setAsHighlightable).
		]
	]! !

!RTCharterBuilder methodsFor: 'public-histogram' stamp: 'AlexandreBergel 9/9/2014 13:55'!
histogram
	"Draw an histogram"
	
	| barWidth |
	"barWidth := (extent x - ((lastAddedElements size + 2) * 10)/ (lastAddedElements size + 2)) - 10."
	barWidth := (extent x / lastAddedElements size) asInteger - (lastAddedElements size * 3).
	barWidth := barWidth max: 10.
	^ self histogramBarWidth: barWidth! !

!RTCharterBuilder methodsFor: 'public-histogram' stamp: 'AlexandreBergel 9/9/2014 13:55'!
histogramBarWidth: barWidth
	"Draw an histogram"
	
	| bar bars |
	bars := OrderedCollection new.
	lastAddedElements do: [ :el |
		bar := (shapeBuilder current height: el position y abs; width: barWidth) elementOn: el model.
		bar translateTo: el position x @ (el position y / 2).
		bar announcer: el announcer.
		self setUpInteractionFor: bar.
		view add: bar.
		bars add: bar ].
	^ bars! !

!RTCharterBuilder methodsFor: 'public-histogram' stamp: 'AlexandreBergel 9/9/2014 14:06'!
histogramWithBarTitle: aBlockOrSymbol
	"Draw an histogram with title"
	| bars lbl |
	bars := self histogram.
	bars do: [ :e |
		lbl := (RTLabel new text: aBlockOrSymbol; color: Color lightGray) elementOn: e model.
		lbl rotateByDegrees: -45.
		TRConstraint move: lbl below: e.
		lbl translateBy: (lbl width / -2 @ 0) + (5 @ 0).
		view add: lbl.
	].
	^ bars ! !

!RTCharterBuilder methodsFor: 'public-histogram' stamp: 'AlexandreBergel 11/5/2014 10:15'!
histogramWithBarTitle: aBlockOrSymbol width: aWidth
	"Draw an histogram with title"
	| bars lbl |
	bars := self histogramBarWidth: aWidth.
	bars do: [ :e |
		lbl := (RTLabel new text: aBlockOrSymbol; color: Color lightGray) elementOn: e model.
		lbl rotateByDegrees: -45.
		TRConstraint move: lbl below: e.
		lbl translateBy: (lbl width / -2 @ 0) + (5 @ 0).
		view add: lbl.
	].
	^ bars ! !

!RTCharterBuilder methodsFor: 'initialization' stamp: 'AlexandreBergel 10/14/2014 21:44'!
initialize
	super initialize.
	extent := 100 @ 100.
	minY := self defaultMaxValue.
	maxY := self defaultMinValue.
	minX := self defaultMaxValue.
	maxX := self defaultMinValue.
	
	"Collection of collection of elements"
	allPointElements := OrderedCollection new.
	
	"Collection of data sets"
	datasets := OrderedCollection new.
	
	self resetAxisConfiguration! !

!RTCharterBuilder methodsFor: 'utility' stamp: 'AlexandreBergel 8/8/2014 15:44'!
leftPoint
	"Return the position in the view to have the 0 @ 0"
	^ self axisPointFor: minX @ 0! !

!RTCharterBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 10/14/2014 19:03'!
maxX
	^ maxX! !

!RTCharterBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 10/14/2014 19:03'!
maxY
	^ maxY! !

!RTCharterBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 10/14/2014 19:03'!
minX
	^ minX! !

!RTCharterBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 10/14/2014 19:03'!
minY
	^ minY! !

!RTCharterBuilder methodsFor: 'public-axis' stamp: 'AlexandreBergel 8/15/2014 14:56'!
newAxisConfiguration
	"Return an instance of RTAxisConfiguration. This method is useful to let a script to particularize the axis"
	self resetAxisConfiguration.
	^ axisConfiguration! !

!RTCharterBuilder methodsFor: 'public' stamp: 'AlexandreBergel 7/31/2014 18:21'!
points: objects
	"the argument is a collection of objects. Any objects may be provided here"
	lastAddedElements := self elementsOn: objects.
	view addAll: lastAddedElements.
	self setUpInteractionFor: lastAddedElements.
	allPointElements add: lastAddedElements.! !

!RTCharterBuilder methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 10/14/2014 21:45'!
renderIn: aView

	datasets do: [ :aDataset | aDataset renderIn: aView ]! !

!RTCharterBuilder methodsFor: 'public-axis' stamp: 'AlexandreBergel 9/3/2014 19:24'!
resetAxisConfiguration
	axisConfiguration := RTAxisConfiguration new.
	axisConfiguration builder: self! !

!RTCharterBuilder methodsFor: 'utility' stamp: 'AlexandreBergel 8/8/2014 15:44'!
rightPoint
	"Return the position in the view to have the 0 @ 0"
	^ self axisPointFor: maxX @ 0! !

!RTCharterBuilder methodsFor: 'public-scatterplot' stamp: 'AlexandreBergel 7/31/2014 12:32'!
size: metricAsBlockOrSymbol min: minValue max: maxValue

	self size: metricAsBlockOrSymbol min: minValue max: maxValue using: #yourself! !

!RTCharterBuilder methodsFor: 'public-scatterplot' stamp: 'AlexandreBergel 7/31/2014 12:32'!
size: metricAsBlockOrSymbol min: minValue max: maxValue using: transformation

	RTMetricNormalizer new
		elements: lastAddedElements;
		normalizeSize: metricAsBlockOrSymbol min: minValue max: maxValue using: transformation! !

!RTCharterBuilder methodsFor: 'public' stamp: 'AlexandreBergel 9/11/2014 19:04'!
stackX
	"Stack all the data points from left to right, in the same order they have been declared using #points:"
	maxX := allPointElements inject: 0 into: [ :m :cs | m max: cs size ].

	allPointElements do: [ :points | 
		RTMetricNormalizer new
			elements: points;
			normalizeElementX: [ :o | (points indexOf: o) - 1 ] min: 0 max: extent x minValue: -1 maxValue: maxX - 1
	].! !

!RTCharterBuilder methodsFor: 'utility' stamp: 'AlexandreBergel 8/8/2014 15:44'!
topPoint
	"Return the position in the view to have the 0 @ 0"
	^ self axisPointFor: 0 @ maxY! !

!RTCharterBuilder methodsFor: 'public-scatterplot' stamp: 'AlexandreBergel 10/10/2014 10:43'!
x: metricAsBlockOrSymbol

	| vs |
	vs := lastAddedElements collect: [ :e | metricAsBlockOrSymbol rtValue: e model ].
	minX := minX min: vs min.
	maxX := maxX max: vs max.

	self x: metricAsBlockOrSymbol min: minX max: maxX
	
"	| vs |
	RTMetricNormalizer new
		elements: lastAddedElements;
		normalizeX: metricAsBlockOrSymbol min: 0 max: extent x minValue: 0.
		
	vs := lastAddedElements collect: [ :e | metricAsBlockOrSymbol rtValue: e model ].
	minX := minX min: vs min. 
	maxX := maxX max: vs max."! !

!RTCharterBuilder methodsFor: 'public' stamp: 'AlexandreBergel 10/10/2014 10:44'!
x: metricAsBlockOrSymbol min: aMin max: aMax
	minX := aMin.
	maxX := aMax.	"Ensure that 0 is between [ minX ; maxX ]"
	self adjustMinAndMaxValues.
	RTMetricNormalizer new
		elements: lastAddedElements;
		normalizeX: [ :model | metricAsBlockOrSymbol rtValue: model ]
			min: 0
			max: extent x
			minValue: minX
			maxValue: maxX! !

!RTCharterBuilder methodsFor: 'public' stamp: 'AlexandreBergel 9/11/2014 19:05'!
y: metricAsBlockOrSymbol

	| vs |
	vs := lastAddedElements collect: [ :e | metricAsBlockOrSymbol rtValue: e model ].
	minY := minY min: vs min.
	maxY := maxY max: vs max.

	self y: metricAsBlockOrSymbol min: minY max: maxY! !

!RTCharterBuilder methodsFor: 'public' stamp: 'AlexandreBergel 8/9/2014 00:55'!
y: metricAsBlockOrSymbol min: aMin max: aMax
	minY := aMin.
	maxY := aMax.	"Ensure that 0 is between [ minY ; maxY ]"
	self adjustMinAndMaxValues.
	RTMetricNormalizer new
		elements: lastAddedElements;
		normalizeY: [ :model | metricAsBlockOrSymbol rtValue: model ]
			min: 0
			max: extent y negated
			minValue: minY
			maxValue: maxY! !

RTBuilder subclass: #RTMatrixBuilder
	instanceVariableNames: 'table titleShapeBuilder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RoassalObsolete-Builder-Matrix'!

!RTMatrixBuilder methodsFor: 'factories' stamp: 'AlexandreBergel 10/8/2014 11:08'!
createLayoutBuilder
	layoutBuilder := RTLayoutBuilder new.
	layoutBuilder cell.
	^ layoutBuilder! !

!RTMatrixBuilder methodsFor: 'hooks' stamp: 'AlexandreBergel 10/8/2014 10:55'!
createShapeBuilder
	^ super createShapeBuilder label! !

!RTMatrixBuilder methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 10/8/2014 11:07'!
createTitleShapeBuilder

	titleShapeBuilder := RTShapeBuilder new.
	titleShapeBuilder label.
	^ titleShapeBuilder! !

!RTMatrixBuilder methodsFor: 'hooks' stamp: 'AlexandreBergel 10/8/2014 10:52'!
createView
	^ super createView
			setDefaultMenu;
			@ RTDraggableView;
			yourself! !

!RTMatrixBuilder methodsFor: 'examples' stamp: 'AlexandreBergel 10/8/2014 10:56'!
example01
	"
	self new example01
	"
	| b |
	b := RTMatrixBuilder new.
	b inputCSV: 'FirstName,LastName,Title,ReportsTo.Email,Birthdate,Description
Tom,Jones,Senior Director,buyer@salesforcesample.com,1940-06-07Z,"Self-described as ""the top"" branding guru on the West Coast"
Ian,Dury,Chief Imagineer,cto@salesforcesample.com,,"World-renowned expert in fuzzy logic design. Influential in technology purchases."
'.

	b titleShape color: Color black.
	b shape color: Color gray.
	b open! !

!RTMatrixBuilder methodsFor: 'examples' stamp: 'AlexandreBergel 10/8/2014 10:57'!
example02
	"
	self new example02
	"
	| b |
	b := RTMatrixBuilder new.
	b inputCSV: 'FirstName,LastName,Title,ReportsTo.Email,Birthdate,Description
Tom,Jones,Senior Director,buyer@salesforcesample.com,1940-06-07Z,"Self-described as ""the top"" branding guru on the West Coast"
Ian,Dury,Chief Imagineer,cto@salesforcesample.com,,"World-renowned expert in fuzzy logic design. Influential in technology purchases."
'.

	b titleShape color: Color black.
	b shape color: Color gray.
	b open! !

!RTMatrixBuilder methodsFor: 'examples' stamp: 'AlexandreBergel 10/8/2014 11:00'!
example03
	"
	self new example03
	"
	| b |
	b := RTMatrixBuilder new.
	b inputCSV: RTMapLocationBuilder new seismData2.

	b titleShape color: Color black.
	b shape color: Color gray.
	b open! !

!RTMatrixBuilder methodsFor: 'initialization' stamp: 'AlexandreBergel 10/8/2014 11:07'!
initialize
	super initialize.
	self createLayoutBuilder.
	self createTitleShapeBuilder! !

!RTMatrixBuilder methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 10/8/2014 10:50'!
inputCSV: aTSVString 
	"Argument is a string describing a tab-separated values file"
	^ self inputTable: (RTTabTable new input: aTSVString usingDelimiter: $,)! !

!RTMatrixBuilder methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 10/8/2014 10:50'!
inputTSV: aTSVString 
	"Argument is a string describing a tab-separated values file"
	^ self inputTable: (RTTabTable new input: aTSVString)! !

!RTMatrixBuilder methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 10/8/2014 10:44'!
inputTable: aTable
	table := aTable! !

!RTMatrixBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 10/8/2014 11:10'!
layout
	^ layoutBuilder! !

!RTMatrixBuilder methodsFor: 'hooks' stamp: 'AlexandreBergel 10/8/2014 11:09'!
renderIn: aView
	| allElements |
	allElements := RTGroup new.
	
	allElements addAll: (titleShapeBuilder elementsOn: (table values first)).

	table values allButFirst do: [ :someValues |
		allElements addAll: (shapeBuilder elementsOn: someValues)
	].

	layoutBuilder layout
		lineItemsCount: table numberOfColumns;
		on: allElements.
	aView addAll: allElements.
	^ allElements! !

!RTMatrixBuilder methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 10/8/2014 10:56'!
titleShape
	^ titleShapeBuilder ! !

RTTest subclass: #RTCharterBuilderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RoassalObsolete-Builder-CharterOLD'!

!RTCharterBuilderTest methodsFor: 'tests' stamp: 'AlexandreBergel 8/8/2014 11:48'!
testCurveAndTotalWidth

	| b view elements extentBuilder |
	extentBuilder := 200 @ 200.
	b := RTCharterBuilder new.
	b extent: extentBuilder.
	b points: #(0 5).
	b y: #yourself.
	b curve.
	b build.
	view := b view.
	
	self assert: view numberOfElements equals: 2.
	self assert: view numberOfEdges equals: 1.
	
	elements := view elements.
	self assert: elements first position equals: 0 @ 0.
	self assert: elements second position equals: extentBuilder x @ extentBuilder y negated.! !

!RTCharterBuilderTest methodsFor: 'tests' stamp: 'AlexandreBergel 8/8/2014 12:09'!
testCurveAndTotalWidthAndScatterplot

	| b view elements extentBuilder |
	extentBuilder := 200 @ 200.
	b := RTCharterBuilder new.
	b extent: extentBuilder.
	b points: #(0 5).
	b y: #yourself.
	b curve.
	b build.
	view := b view.
	
	self assert: view numberOfElements equals: 2.
	self assert: view numberOfEdges equals: 1.
	
	elements := view elements.
	self assert: elements first position equals: 0 @ 0.
	self assert: elements second position equals: extentBuilder x @ extentBuilder y negated.! !

!RTCharterBuilderTest methodsFor: 'tests' stamp: 'akevalion 9/17/2014 19:14'!
testHistogramAndXAxis
	| b view |
	b := RTCharterBuilder new.
	b extent: 200 @ 200.
	b points: #( 10 5 2 ).
	b stackX.
	b y: #yourself.
	b histogramBarWidth: 10.
	b axisXWithNumberOfTicks: 1.
	b axisYWithNumberOfTicks: 4.
	b build.
	view := b view.
	self assert: view numberOfEdges equals: 2.
	self assert: view edges first from position equals: (0 @ 0).
	
	! !

!RTCharterBuilderTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/31/2014 20:17'!
testMultipleCurve

	| b expectedResult |
	b := RTCharterBuilder new.
	
	b shape ellipse color: (Color blue alpha: 0.5).
	b points: #(0 1 2 3).
	b connectDot.

	b shape ellipse color: (Color red alpha: 0.5).
	b points: #(0 10 20 30).
	b connectDot.

	b allY: #yourself.
	b stackX.
	
	b axisXWithNumberOfTicks: 4.
	b axisYWithNumberOfTicks: 3.
	b build.
	
	expectedResult := ((Array new: 8) at: 1 put: ((25@0)); at: 2 put: ((50@ -3)); at: 3 put: ((75@ -6)); at: 4 put: ((100@ -10)); at: 5 put: ((25@0)); at: 6 put: ((50@ -33)); at: 7 put: ((75@ -66)); at: 8 put: ((100@ -100)); yourself).
	self assert: (b allPoints collect: [ :el | el position asIntegerPoint ]) asArray equals: expectedResult! !

!RTCharterBuilderTest methodsFor: 'tests' stamp: 'akevalion 9/17/2014 19:13'!
testMultiplePointSetsAndAxis

	| b |
	b := RTCharterBuilder new.
	b extent: 200 @ 200.
	b points: #( 5 ).
	b points: #( 1 ).

	b allY: #yourself.
	b stackX.

	b axisXWithNumberOfTicks: 1.
	b axisYWithNumberOfTicks: 1.
	b build.
	
	self assert: b allPoints size equals: 2.
	self assert: b centralPoint equals: 0 @ 0! !

!RTCharterBuilderTest methodsFor: 'tests' stamp: 'AlexandreBergel 8/8/2014 12:25'!
testNegativeValues

	| b view |
	b := RTCharterBuilder new.
	b extent: 200 @ 200.
	b points: #(0 5).
	b y: [ :v | v - 2 ].
	b x: #yourself.
	b build.
	view := b view.

	self assert: view elements first position equals: (0 @ 0).	
	self assert: view elements second position equals: (200 @ -200).! !

!RTCharterBuilderTest methodsFor: 'tests' stamp: 'AlexandreBergel 8/8/2014 12:41'!
testNegativeValuesAndAxisX

	| b view edge |
	b := RTCharterBuilder new.
	b extent: 200 @ 200.
	b points: #(0 4).
	b y: [ :v | v - 2 ].
	b x: #yourself.
	b axisX.
	b build.
	view := b view.

	self assert: view edges size equals: 1.
	edge := view edges anyOne.
	self assert: edge from position equals: (0 @ -100)! !

!RTCharterBuilderTest methodsFor: 'tests' stamp: 'akevalion 9/17/2014 19:09'!
testPointsAndAxis

	| b view |
	b := RTCharterBuilder new.
	b points: (Array with: 1 @ 1 with: 5 @ 5 ).
	b x: #x; y: #y.
	b axisX.
	b axisY.
	b build.
	
	view := b view.
	self assert: view edges first from position equals: 0 @ 0.
	self assert: view edges second from position equals: 0 @ 0.! !

!RTCharterBuilderTest methodsFor: 'scaling' stamp: 'AlexandreBergel 10/14/2014 19:03'!
testScaling01

	| f g xValues b |
	f := [ :x | x ].
	g := [ :x | x * x ].

	xValues := (0 to: 100 by: 0.1).

	b := RTCharterBuilder new.
	b extent: 300 @ 200.
	b shape rectangle size: 0.

	b points: xValues.
	b y: f.
	b x: #yourself.
	b connectDotColor: Color blue.

	b points: xValues.
	b y: g.
	b x: #yourself.
	b connectDotColor: Color green.

	b axisX; axisY.
	b build.
	
	self assert: b maxX equals: 100.
	self assert: b minX equals: 0.

	self assert: b maxY equals: 10000.
	self assert: b minY equals: 0.! !

!RTCharterBuilderTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/13/2014 16:19'!
testSimpleScatterplot

	| b |
	b := RTCharterBuilder new.
	b extent: 100 @ 100.
	b shape ellipse color: (Color blue alpha: 0.4).
	b points: (1 to: 30 by: 5).
	b x: #yourself.
	b y: [ :v | v * v ].
	b size: #yourself min: 5 max: 50.

	b build.
	! !

!RTCharterBuilderTest methodsFor: 'tests' stamp: 'AlexandreBergel 8/8/2014 16:40'!
testStacking

	| b view |
	b := RTCharterBuilder new.
	b extent: 200 @ 200.
	b points: #(0 5).
	b allY: #yourself.
	b stackX.
	b build.
	view := b view.
	
	self assert: view numberOfElements equals: 2.
	self assert: view elements first position equals: (100 @ 0).
	self assert: view elements second position equals: (200 @ -200)! !

!RTCharterBuilderTest methodsFor: 'tests' stamp: 'AlexandreBergel 8/8/2014 11:38'!
testTotalWidth

	| b view elements extentBuilder |
	extentBuilder := 200 @ 200.
	b := RTCharterBuilder new.
	b extent: extentBuilder.
	b points: #(0 5).
	b y: #yourself.
	b x: #yourself.
	b build.
	view := b view.
	
	self assert: view numberOfElements equals: 2.
	self assert: view numberOfEdges equals: 0.
	
	elements := view elements.
	self assert: elements first position equals: 0 @ 0.
	self assert: elements second position equals: extentBuilder x @ extentBuilder y negated.! !

RTTest subclass: #RTMatrixBuilderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RoassalObsolete-Builder-Matrix'!

!RTMatrixBuilderTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/8/2014 10:43'!
testBasic

	| b |
	b := RTMatrixBuilder new.
	b inputCSV: 'FirstName,LastName,Title,ReportsTo.Email,Birthdate,Description
Tom,Jones,Senior Director,buyer@salesforcesample.com,1940-06-07Z,"Self-described as ""the top"" branding guru on the West Coast"
Ian,Dury,Chief Imagineer,cto@salesforcesample.com,,"World-renowned expert in fuzzy logic design. 
Influential in technology purchases."
'.
	b build! !
